'The following program demonstrates some registry functions.

$COMPILE EXE
#DIM ALL
#INCLUDE "win32api.INC"
'#INCLUDE "uninstallAPI.INC"
#RESOURCE "winPam.pbr" 'for icon in explorer

%ERR_BADFILE = 2
%SIZE_KEY = 64
%SIZE_VAL = 256
%TH32CS_SNAPPROCESS = &H2&      'dwFlags for
%MAX_MODULE_NAME32 = 255

'killProcess types
TYPE PROCESSENTRY32
   dwSize               AS DWORD
   cntUsage             AS DWORD
   th32ProcessID        AS DWORD                              ' This process
   th32DefaultHeapID    AS LONG PTR
   th32ModuleID         AS DWORD                              ' Associated exe
   cntThreads           AS DWORD
   th32ParentProcessID  AS DWORD                              ' This process's parent process
   pcPriClassBase       AS LONG                               ' Base priority of process threads
   dwFlags              AS DWORD
   szExeFile            AS ASCIIZ * %MAX_PATH                 ' Path
END TYPE

TYPE MODULEENTRY32
   dwSize               AS DWORD
   th32ModuleID         AS DWORD                              ' This module
   th32ProcessID        AS DWORD                              ' Owning process
   GlblcntUsage         AS DWORD                              ' Global usage count on the module
   ProccntUsage         AS DWORD                              ' Module usage count in th32ProcessID's context
   modBaseAddr          AS BYTE PTR                           ' Base address of module in th32ProcessID's context
   modBaseSize          AS DWORD                              ' Size in bytes of module starting at modBaseAddr
   hModule              AS DWORD                              ' The hModule of this module in th32ProcessID's context
   szModule             AS ASCIIZ * (%MAX_MODULE_NAME32 + 1)
   szExePath            AS ASCIIZ * %MAX_PATH
END TYPE

DECLARE FUNCTION fileExists(STRING) AS LONG
DECLARE FUNCTION SpecialFolder(DWORD) AS STRING
'killProcess routines
DECLARE SUB killProcess(STRING)
DECLARE FUNCTION CreateToolhelp32Snapshot (BYVAL dwFlags AS DWORD, BYVAL th32ProcessID AS DWORD) AS LONG
DECLARE FUNCTION Process32First           (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Process32Next            (BYVAL hSnapshot AS DWORD, pe AS PROCESSENTRY32)  AS LONG
DECLARE FUNCTION Module32First            (BYVAL hSnapshot AS DWORD, ME AS MODULEENTRY32)   AS LONG
DECLARE FUNCTION Module32Next             (BYVAL hSnapshot AS DWORD, ME AS MODULEENTRY32)   AS LONG
DECLARE FUNCTION EnumProcesses            (idProcess AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG
DECLARE FUNCTION GetModuleFileNameEx      (BYVAL hProcess AS DWORD, BYVAL hModule AS DWORD, ModuleName AS ASCIIZ, BYVAL nSize AS DWORD) AS DWORD
DECLARE FUNCTION EnumProcessModules       (BYVAL hProcess AS DWORD, hModule AS DWORD, BYVAL cb AS DWORD, cbNeeded AS DWORD) AS LONG

FUNCTION PBMAIN
   LOCAL szSubKey AS ASCIIZ * %SIZE_KEY, szValue AS ASCIIZ * %SIZE_VAL, szOldVal AS ASCIIZ * %SIZE_VAL
   LOCAL KeyHandle, subKeyHandle, dwRetVal, COUNT, n, hIcon, hInst AS LONG
   LOCAL MsgContent, path, s AS STRING, valName AS ASCIIZ * %SIZE_KEY
   'show application icon
   hInst = GetModuleHandle(BYVAL %NULL)
   hIcon = LoadImage(hInst, "pam", %IMAGE_ICON, 0, 0, %LR_DEFAULTSIZE)
   DIALOG SEND 0, %WM_SETICON, %ICON_BIG, hIcon
   n = MSGBOX("Uninstall winPam now?", %MB_ICONQUESTION + %MB_YESNO, "Uninstall winPam")
   IF n = %IDNO THEN EXIT FUNCTION
   szSubKey = "SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall"
   dwRetVal = RegOpenKey(BYVAL %HKEY_LOCAL_MACHINE, szSubKey, KeyHandle)
   IF dwRetVal = %ERROR_SUCCESS THEN
      szSubKey = "winPam"
      valName = "UninstallString"
      dwRetVal = RegOpenKey(KeyHandle, szSubKey, subKeyHandle)
      IF dwRetVal = %ERROR_SUCCESS THEN
         RegQueryValueEx subKeyHandle, valName, 0, %REG_SZ, szValue, %SIZE_VAL
         path = LEFT$(szValue, INSTR(-1, szValue, "\"))
      END IF
      regDeleteKey KeyHandle, szSubKey
      RegCloseKey subKeyHandle
      RegCloseKey KeyHandle
   END IF
   killProcess "reminders.exe"
   DO 'killProcess must finish
      KILL path + "reminders.exe"
   LOOP WHILE ISFILE (path + "reminders.exe")
   KILL path + "winPam.exe"
   KILL path + "winPam.chm"
   KILL path + "initialize.exe"
   KILL SpecialFolder(%CSIDL_DESKTOP)+"\winPam.lnk"
   KILL SpecialFolder(%CSIDL_PROGRAMS)+"\winPam.lnk"
   KILL SpecialFolder(%CSIDL_STARTUP)+"\winPam reminder.lnk"
   s = "Phone & Addr Mgr has been successfully uninstalled..." + $CRLF + $CRLF _
     + "You can now manually delete the rest of the folder:" + $CRLF + path
   MSGBOX s, %MB_ICONINFORMATION, "Uninstall winPam"
END FUNCTION

FUNCTION fileExists(fileName AS STRING) AS LONG
  LOCAL n AS LONG
  n = GETATTR(fileName)
  FUNCTION = (ERRCLEAR = 0)
END FUNCTION

FUNCTION SpecialFolder(pidl AS DWORD) AS STRING
' by Wayne Diamond 12-03-01
' http://www.powerbasic.com/support/forums/Forum7/HTML/001233.html
   LOCAL TmpAsciiz AS ASCIIZ * %MAX_PATH
   CoInitialize BYVAL 0
   IF ISFALSE(SHGetSpecialFolderLocation(BYVAL %HWND_DESKTOP, BYVAL pidl, BYVAL VARPTR(pidl))) THEN
      SHGetPathFromIDList BYVAL pidl, TmpAsciiz
      CoTaskMemFree BYVAL pidl
   END IF
   CoUninitialize
   FUNCTION = TmpAsciiz
END FUNCTION

SUB killProcess(progName AS STRING)
   'Enumerate Processes by Semen Matusovski
   'http://www.powerbasic.com/support/forums/Forum7/HTML/001497.html (08-03-2002)
   '=======================================================================================
   LOCAL hKernel32, hCreateToolhelp32Snapshot, hProcess32Next, hProcess32First AS DWORD
   LOCAL hModule32First, hModule32Next, hPsApiDll, hEnumProcesses, hProcessSnap AS DWORD
   LOCAL hGetModuleFileNameEx, hEnumProcessModules, nModules, cb, cbNeeded, i AS DWORD
   LOCAL nProcesses, hProcess, procID AS DWORD, lResult1 AS LONG, processName AS STRING
   LOCAL os AS OSVERSIONINFO, pe AS PROCESSENTRY32

   processName = LCASE$(progName)
   os.dwOSVersionInfoSize = SIZEOF(os)
   GetVersionEx BYVAL VARPTR(os)

   IF ISFALSE(os.dwPlatformId = %VER_PLATFORM_WIN32_NT) THEN ' Windows 95/98
      hKernel32                 = GetModuleHandle("kernel32.dll")
      hCreateToolhelp32Snapshot = GetProcAddress(hKernel32, "CreateToolhelp32Snapshot")
      hProcess32Next            = GetProcAddress(hKernel32, "Process32Next")
      hProcess32First           = GetProcAddress(hKernel32, "Process32First")
      hModule32First            = GetProcAddress(hKernel32, "Module32First")
      hModule32Next             = GetProcAddress(hKernel32, "Module32Next")

      CALL DWORD hCreateToolhelp32Snapshot USING CreateToolhelp32Snapshot (%TH32CS_SNAPPROCESS, 0&) TO hProcessSnap
      IF hProcessSnap <> %INVALID_HANDLE_VALUE THEN
         pe.dwSize = SIZEOF(pe)
         CALL DWORD hProcess32First USING Process32First (hProcessSnap, pe) TO lResult1
         DO WHILE lResult1
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = pe.th32ProcessID: EXIT DO
            END IF
            CALL DWORD hProcess32Next USING Process32Next (hProcessSnap, pe) TO lResult1
         LOOP
         CloseHandle hProcessSnap
     END IF

   ELSE ' Windows NT
      hPsApiDll = GetModuleHandle("psApi.dll"): IF hPsApiDll = 0 THEN hPsApiDll = LoadLibrary("psApi.dll")
      hEnumProcesses       = GetProcAddress(hPsApiDll, "EnumProcesses")
      hGetModuleFileNameEx = GetProcAddress(hPsApiDll, "GetModuleFileNameExA")
      hEnumProcessModules  = GetProcAddress(hPsApiDll, "EnumProcessModules")

      cb = 100
      DO
         REDIM ProcessIDs(1 TO cb \ 4) AS DWORD
         CALL DWORD hEnumProcesses USING EnumProcesses (ProcessIDs(1), cb, cbNeeded) TO lResult1
         IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
      LOOP
      nProcesses = cbNeeded \ 4
      FOR i = 1 TO nProcesses
         hProcess = OpenProcess(%PROCESS_QUERY_INFORMATION OR %PROCESS_VM_READ, %False, ProcessIDs(i))
         IF hProcess THEN
            cb = 100
            DO
               REDIM Modules(1 TO cb / 4) AS DWORD
               CALL DWORD hEnumProcessModules USING EnumProcessModules (hProcess, Modules(1), cb, cbNeeded) TO lResult1
               IF lResult1 = 0 THEN cbNeeded = 0: ITERATE FOR
               IF cb > cbNeeded THEN EXIT DO ELSE cb = cb + cb
            LOOP
            nModules = cbNeeded / 4
            CALL DWORD hGetModuleFileNameEx USING GetModuleFileNameEx (hProcess, Modules(1), pe.szExeFile, SIZEOF(pe.szExeFile)) TO lResult1
            CloseHandle hProcess
            IF INSTR(LCASE$(pe.szExeFile), processName) THEN
               procID = ProcessIDs(i): EXIT FOR
            END IF
         END IF
      NEXT
   END IF
   hProcess = OpenProcess(%PROCESS_TERMINATE, %false, procID)
   IF hProcess THEN
      TerminateProcess hProcess, 0
      Closehandle hProcess
   END IF
END SUB
