'WinPam - Phone & Address Manager by Charles Dietz
'----------------------------------------------------------------------------------
'ver 2.35, 03-21-2002                                                  
' - Setup labels and envelopes in Install.exe program
' - Add 2 dimensions for envelope printing in properties
' - Added import/export feature using text with commas
'ver 2.36, 01-06-2003
' - corrected reminders
' - corrected reminders print
'ver 2.37, 09-16-2003
' - corrected printerDC for Windows NT, 2000, XP
'ver 2.38, 10-21-03          
' - replaced Mark toolbar button with Reminders button
' - view reminders beginning with first to occur
' - added Special list (begin lastname with !number)
' - improved marking by using SHFT or CTRL keys, deleted dblclk
' - now show reminders list beginning with today
'ver 2.39, 11-01-03
' - used CreateStatusWindow in addStatusBar
' - added merge records feature
'ver 2.40, 12-31-03
' - corrected reminder errors occuring at transition to new year
' - allow reminder date textbox room to include year
'ver 2.41, 01-31-04
' - corrected address book print (phone numbers did not print)
' - display 4th phone number when dialing (even when labeled as fax)
'ver 2.42, 03-06-04
' - corrected deletion of edited reminders
' - corrected errors and improved code in reminder.bas
' - reminder.exe to remain loaded (memory resident)
'   check beginning of every new day at 12:01 am
'ver 2.43, 04-15-04
' - corrected condition of no reminder file found in folder
' - corrected error when checking reminders for beginning of new day
'ver 2.44, 07-08-04
' - corrected edit display when defining tabs for properties
' - corrected minor bugs with export
' - changed reminder dialog to modeless parent
'   (calendar can show at the same time)
'ver 2.45, 08-10-04
' - corrected help file call from menu click (Windows 98 only)
' - corrected GPF printing errors (no label, envelop properties)
' - require choice of printer from printer dialog (no default anymore)
' - improved printing for any windows printers with different resolutions
' - corrected find not searching special entries
' - corrected condition of empty reminder file (no reminders)
'ver 2.46, 10-08-04
' - needed tabNo = 0 after opening new file (clicking same tab was inactive)
' - added two more dialing prefixes for total of 3
' - corrected minor bugs in dialPhoneProc
'ver 2.47, 12-02-04
' - allow for 3 fixed reminder events: 'birthday', 'anniversary', and 'appointment'
' - added reminder time to appointment
' - added daily reminders
' - reminder dates no longer must be future dates, update compensates for it
' - dialing dialog: change position of prefix and correct for phonecard names
' - saveTheFile corrected to account for list changes
'ver 2.48, 02-02-05
' - added 6 mini pages per sheet to address book printing
' - added double sided printing
' - improved 'print address book' dialog box
' - corrections in file merge
' - corrections to override MS Listbox default positioning using LB_SETTOPINDEX
' - corrections to marking with shft and ctrl
' - fixed calendar when starting in January
' - improved choosePrinter routine
' - added appointment time when showing reminder
' - fixed problem with repeated voice after modem dialing
'ver 2.49, 02-08-05
' - fixed selecting menu items with keybd (using keyboard hook)
' - allow Ctrl+A to mark all shown, ESC to remove all marking
' - integrated all marking options into one routine, markRecords()
' - removed line skip while printing single line
' - corrected margins for printing back side
'ver 2.50, 03-01-05
' - eliminate %MaxRecords... redim as needed
' - delete only the highlighted record, even with marked records
' - undo last delete or replace operation
'   change bit 0 of flag from deleted to replaced record
'   add array undel() for level of deleted (or replaced) records
'   undel(i): low word for undo level, high word for new record
'   add subs Delete and Undo for clarity
' - fixed margin error for 2 page format of print address
' - fixed merge data record deletion
' - fixed single line, full page printing (phone numbers)
'ver 2.60, 10-20-05
' - improved dialing procedure using TAPI rather than Hays commands
' - allow double click to display dialog box for dialing
' - added feature to dial an unrecorded phone numbers... dialX
' - allow alpha characters with dialX (Q&Z included from Properties)
' - removed sending email feature (not the right application for it)
' - corrected dialing prefixes when more than one is defined
'ver 2.61, 11-12-05
' - Used Tapi 1.4 rather than 2.0 for better Windows 98 compatibility
' - prompt when quiting record data after it has been added or changed
' - corrected bugs dealing with lists and selecting
'ver 2.62, 01-24-06
' - keep listbox scroll position after marking
' - fixed problem of winPam not opening up (dialingNow var)
' - fixed problem entering description in reminders
'ver 2.63, 03-07-06
' - fixed problem with importing
' - print addr book (include records beginning with numbers & special records)
' - changed close data form prompt when data has changed
'ver 2.70, 08-20-06
' - added weekday to reminder form in winPam
' - recoded calendar as a function allowing selection
'ver 2.71, 08-28-06
' - truncated reminder description when too long
' - converted truncateStr() to function
'ver 2.83, 10-16-06
' - added time to list of reminders and changed format of date
' - made reminders child of main dialog
'ver 2.84, 10-25-06
' - corrected print for reminder list (columns for different printer dpi's)
'ver 2.85, 12-14-06
' - added weekday column to reminder list
'ver 2.86, 08-29-07
' - corrected reminder problems for first hour after midnight (e.g. 12:01 am)
' - corrected problem clearing bits 0 and 2 (65531 should have been 65530)
'ver 2.87, 09-30-07
' - corrected desktop position of reminders dialog (xReminders.bas)
' - changed default install to C:\Program Files\cgdSoftware\winPam
'ver 2.88, 10-21-07
' - made installation compliant with MS Windows Vista
'   default program folder: %CSIDL_PROGRAM_FILES + "\cgdSoftware\winPam\"
'   default data folder: %CSIDL_COMMON_DOCUMENTS + "\cgdSoftware\winPam\"
' - improve properties when Ini file is absent (added winPamIni in Program Files)
' - correct printing problem, added di.cbSize, di.lpszDocName assignments
'   (detected on EV Free Church printers for Attendance program)
'ver 2.89, 01-21-08
' - corrected printer enumeration in choosePrinterProc (replaced $NUL by BYVAL 0)
' - added option of printing without alphabetical tab headers
' - disallowed list printing with special records (!)
' - corrected dataFolder determination in initialize
' - override file to open if COMMAND$ (file double-clicked)
'ver 2.90, 2-14-08
' - updated Install.exe
' - updated xReminders.exe
' - changed default '.Pam' to 'Pam' in file list for OPEN (maybe not necessary)
'ver 2.91, 2-16-2008
' - added option to include area code for local calls in properties
'ver 2.92, 3-24-2008
' - changed help file to html help using helpMaker
' - fixed hiLite when deleting record
' - improved data printing
' - added large print for address book
' - corrected data mode - clicking [Next] signaled data change
'ver 2.93, 3-26-2008
' - changed reminder description length to be consistant (not based on 48 chrs)
' - repositioned calendar button next to date and used calendar.bmp
'ver 3.00, 6-21-2008
' - dumped the winPamIni file which had been copied to Program Files... a Vista no-no
' - location of pam file to open is kept in dataFolder + "winPam.ini"
' - dataFolder = specialFolder(%CSIDL_COMMON_DOCUMENTS) + "\cgdSoftware\winPam"
' - version 3.00 will be distributed using my setup wizard (suWizard.exe)
' - hopefully, corrected large notes getting lost (numBytes() AS BYTE in fillRecord fcn)
' - tried to make as many variables as possible LONG (could do more in GLOBAL)
'   (numRecords, numCatgs, numLists must be left as WORD for data files)
'ver 3.01, 7-26-2008
' - corrected bug in saveTheFile (saveNum should have been WORD, not LONG)
'ver 3.02, 8-15-2008
' - added new feature to find reminder
' - added new feature to print reminders for a specified event
'ver 3.03, 8-17-2008
' - corrected and improved process of selecting a print choice
'ver 3.06, 10-09-2009
' - corrected help file
' - added expanded note and find with whole word
' - improved xDial with 'Ok' button before 'Dial now'
'ver 3.07, 12-11-2009
' - change installation slightly (text simplified in initialize.exe)
'ver 3.08, 04-10-2010
' - allow more than 200 reminders
' - corrected help file path
'ver 3.10, 05-24-2010
' - change data storage from _DOCUMENTS to _APPDATA
'ver 3.11, 08-21-2010
' - 3 character bug in text fields (updated "myInput.inc" corrected the problem)
'ver 3.12, 08-31-2010
' - corrected install problems associated with "initialize.exe" and "xSUWizard.exe"
'   (problems were related to collecting files into the data folder Microsoft recommends)
'ver 3.13, 12-06-2010
' - corrected problems associated with saving new file after install (didn't get saved)
' - search expanded note with Next & Prev buttons (F3 & Shft+F3 as well)
' - corrected problem with typing a Find (1st char selected corresponding tab)
' - added password (File menu) to encrypt pamData(i) in openTheFile and saveTheFile
' - converted print choice checkboxes to options and added Ok button
' - corrected expandNote()... Ok button missing when adding new record
'ver 3.15, 07-10-2012
' - added custom labels to the print labels dialog with 3-line content
'ver 3.16, 12-25-2014
' - added 'Rename List' to list menu
' - corrected problem when deleting a list
' - corrected a few other bugs associated with lists
'ver 3.17, 04/27/2015
' - corrected record deletion (hiLite went to top record)
'ver 3.18, 05/20/2015
' - editing phoneID should complete with keyboard ENTER
' - check if invalid phone number only if not in USA 
' - editing phone numbers (should insert '-' after 3rd and 6th digit if not there)
' - list unused events which can then be deleted as desired
' - list last four data files saved on File menu (last opened automatically opens)
' - force File>Open to begin in dataFolder (needed to use DISPLAY OPEN)
'ver 3.19, 11/05/2015
' - copy reminders from folder containing thisFile to dataFolder when saving reminders
'   (the reminders program expects to find the reminders file in dataFolder)                    
' - corrected mouse right click 'Edit' to use 'Edit' tool bar button
' - added prompt to keep expanded note data when exiting out
'ver 3.20, 04/05/2016
' - corrected find feature in showReminders()... dedicated buttons for Next, Prev, Print
' - corrected find feature in expanded notes (may now search without pressing Ok first)
'ver 4.00, 03/03/2017 
' - set pamRecord.dataLength from WORD to DWORD to allow virtually unlimited data storage
' - created SUB UpdateDataFile() to reformat earlier data files to ver 4.00
' - improved password operations
'ver 4.01, 03/18/2017
' - changed expanded note from textbox to richEditText                              
' - improved performance by limiting note textbox to 240 characters
' - minor corrections to password protection and opening another file
'ver 4.02, 03/24/2017
' - corrected bug returning from expanded note truncating large note to just 240 chars
' - added right click menu to both note textbox and expanded note richEdit
' - dblclk now brings up record in edit mode rather than phone dialer 
' - corrected sticky phone numbers when dialing
'ver 4.03, 04/9/2017
' - made small correction in subClasses (used hForm and hExpNote)
'ver 4.04, 05/22/2017
' - neither winPam.exe or reminders.exe can have the security of manifest.xml
'   because the two files must be treated the same so as to read and write reminders.000
'   reminders.exe is launched from Windows Startup and can cannot be prompted for acceptance
'   therefore, we'll just let Windows use the virtualStore folder for holding reminders.000
'ver 4.05, 06/06/2017
' - strip away extraneous code when pasteing
' - when showing data, read-only is sufficient, don't need to disable the rich edit control                               
'ver 4.06, 06/15/2017
' - strip pasted data only worked from floating menu, not from Ctrl+V
' - added ACCEL ATTACH for Ctrl+V on expanded note to allow use of stripClipbd()
' - corrected bug not prompting user to save after a note was pasted
'ver 4.07, 06/28/2017
' - corrected problem with find in expanded note, none found selected all text
' - corrected problems with F3/shft+F3 after no more found
'ver 4.08, 07/26/2017
' - corrected problem with searching expanded note
'ver 4.09, 09/17/2017
' - corrected problem related to awakening from sleep or hibernation (1st record deleted, etc)
' - used appHelp.inc and Tprint.inc from default dir (those files in winAPI are unicode aware)
' - save button in expanded note dimmed unless note is changed
'ver 4.10, 09/18/2017 pending
' - tab listing before sleeping brings back that tab listing
' - a few tweaks here and there
'ver 4.11, 10/18/2017 pending
' - corrected problem pasting data into note field and only 240 characters show in expanded note  
' 
'there seems to be a problem related to password... when Ellen re-enters program it is all hash
'might be something like SAVE, then make more changes so that exiting prompts for another SAVE
'nothing I've tried so far duplicates the problem, however 
'----------------------------------------------------------------------------------------------------
                                 
$RemindFile = "Reminders.000"  '000 extension added ver 3.19
%MaxCatgs         = 100
'%MaxReminders     = 200
%MaxLabels        = 16
%MaxEnvelopes     = 8
%SIZE_KEY         = 64
%SIZE_VAL         = 256
'menu ---------------------------------
%ID_FileMenu      = 100
%ID_Open          = 101
%ID_Save          = 102
%ID_SaveAs        = 103
%ID_Merge         = 104
%ID_Import        = 105
%ID_Export        = 106
%ID_Prop          = 107
%ID_SetPW         = 108
%ID_PrnSetup      = 109
%ID_Print         = 110
%ID_Exit          = 111
%ID_EditMenu      = 200
%ID_MarkSel       = 201
%ID_MarkAll       = 202
%ID_Clear         = 203                    
%ID_ClrAll        = 204
%ID_NewRec        = 205
%ID_EditRec       = 206
%ID_DelRec        = 207
%ID_UnDel         = 208
%ID_Undo          = 221
%ID_Cut           = 222
%ID_Copy          = 223
%ID_Paste         = 224
%ID_Delete        = 225
%ID_SelAll        = 226
%ID_ViewMenu      = 300
%ID_ViewAZ        = 301
%ID_ViewSpec      = 302
%ID_ViewAll       = 303
%ID_ViewData      = 304
%ID_FindRec       = 305
%ID_AddList       = 351
%ID_EditList      = 352
%ID_RenameList    = 353
%ID_DeleteList    = 354
%ID_List1         = 360
%ID_TaskMenu      = 400
%ID_DialPhone     = 401
%ID_xDialPhone    = 402
%ID_PrintData     = 403
%ID_AddrBook      = 404
%ID_Labels        = 405
%ID_Envelopes     = 406
%ID_Calendar      = 407
%ID_Reminder      = 408
%ID_HelpMenu      = 500
%ID_Help          = 501
%ID_About         = 502
'toolbar ------------------------------
%ID_Toolbar       = 600
%ID_DialTB        = 601
%ID_PhoneTB       = 602
%ID_RmindTB       = 603
%ID_FindTB        = 604
%ID_DataTB        = 605
%ID_NewTB         = 606
%ID_EditTB        = 607
%ID_PrintTB       = 608
%ID_QuitTB        = 609
'statusbar ----------------------------
%ID_Statusbar     = 700
%ID_Status1       = 701
%ID_Status2       = 702
%ID_Status3       = 703
%ID_ListBox       = 750
%ID_Password      = 751
%ID_Confirm       = 752
%ID_PasswordHlp   = 753
%ShowWindow       = 800
%ID_TabButtons    = 900
'dataForm -----------------------------
%ID_Lname         = 1001                                               
%ID_Fname         = 1002
%ID_HomePh        = 1003
%ID_BusPh         = 1004
%ID_SelfPh        = 1005
%ID_FaxPh         = 1006
%ID_Email         = 1007
%ID_ToTitle       = 1008
%ID_ToName        = 1009
%ID_Addr1         = 1010
%ID_Addr2         = 1011
%ID_City          = 1012
%ID_Zip           = 1013
%ID_State         = 1014
%ID_Catg          = 1015
%ID_Note          = 1016
%ID_NoteExp       = 1017
%ID_NoteLimit     = 1018                               
%ID_SaveBtn       = 1019
%ID_Add           = 1030
%ID_Close         = 1031
%ID_Cancel        = 1032
%ID_Addr1Label    = 1033
%ID_Addr2Label    = 1034
%ID_CityLabel     = 1035
%ID_ZipLabel      = 1036
%ID_StateLabel    = 1037
%ID_ToTitleTxt    = 1038
%ID_CatgText      = 1039
%ID_ExpandNote    = 1040
%ID_PhoneGrp      = 1050
%ID_AddrGrp       = 1051
%ID_PhoneID       = 1052
%ID_Phone1        = 1053
%ID_Phone2        = 1054
%ID_Phone3        = 1055
%ID_Phone4        = 1056
%ID_PhoneLabel    = 1057
%ID_USA           = 1058
'Labels ----------------------------------
%ID_LabelSize     = 2001
%ID_RetnAddr      = 2002
%ID_MailAddr      = 2003
%ID_CustomLabel   = 2004
'Envelope --------------------------------
%ID_EnvSize       = 2100
'Dial ------------------------------------
%ID_Name          = 3001
%ID_PhNoID        = 3010  '4 phone id's
%ID_PhNo          = 3020  '4 phone numbers
%ID_PhSel         = 3031
%ID_CBprefix      = 3032
%ID_Prefix        = 3033
%ID_DialNow       = 3034
%ID_DialEd        = 3035
%ID_Info          = 3036
%ID_NextCall      = 3037
%ID_CallStatus    = 3038
%ID_PhoneNum      = 3039
'Properties ------------------------------
%ID_AreaCode      = 4001
%ID_PhoneNo       = 4002
%ID_OptPrefix     = 4003
%ID_PhoneChrsQZ   = 4004
%ID_InclAreaCode  = 4005
%ID_CommPort      = 4006
%ID_AutoDetect    = 4007
%ID_LeftPrnMargin = 4008
%ID_LabelSizePref = 4009
%ID_EnvSizePref   = 4010
%ID_EmailAddr     = 4011
%ID_ReturnAddr    = 4012
%ID_OK            = 4013
%ID_LabelName     = 4020
%ID_LabelWidth    = 4021
%ID_LabelHeight   = 4022
%ID_LabelLeft     = 4023
%ID_LabelTop      = 4024
%ID_LabelSpacW    = 4025
%ID_LabelSpacH    = 4026
%ID_NewLabel      = 4027
%ID_RemoveLabel   = 4028
%ID_Compute       = 4029
%ID_EnvName       = 4030
%ID_EnvHorz       = 4031
%ID_EnvVert       = 4032
%ID_NewEnv        = 4033
%ID_RemoveEnv     = 4034
%ID_Tab           = 4100
%ID_TabEd         = 4150
'Find  and Lists -------------------------
%ID_Find          = 5001
%ID_Find0         = 5002
%ID_FindOk        = 5003
%ID_ListName      = 5004
%ID_FindWhole     = 5005
%ID_Next          = 5006
%ID_Prev          = 5007
'Print -----------------------------------
%ID_AllTabs       = 6001
%ID_ThisTab       = 6002
%ID_Marked        = 6003
%ID_PgTitle       = 6004
%ID_OneLine       = 6005
%ID_noPgBreak     = 6006
%ID_noHeaders     = 6007
%ID_FullPage      = 6008
%ID_HalfPage      = 6009
%ID_MiniPage      = 6010
%ID_LargePrn      = 6011
%ID_FrontSide     = 6012
%ID_BackSide      = 6013
'Calendar --------------------------------
%IDC_IncrMo       = 7001
%IDC_DecrMo       = 7002
%IDC_IncrYr       = 7003
%IDC_DecrYr       = 7004
%IDC_Today        = 7005
'Reminders --------------------------------
%ID_ListReminders = 8001
%ID_NewReminder   = 8002
%ID_EditReminder  = 8003
%ID_DelReminder   = 8004
%ID_UnusedEvents  = 8005
%ID_ListUnused    = 8006
%ID_DelEventBtn   = 8007
%ID_FindReminder  = 8008
%ID_PrnReminders  = 8009
%ID_Header        = 8020
%ID_Event         = 8021
%ID_Descr         = 8022
%ID_Date          = 8023
%ID_YearOf        = 8024
%ID_Year          = 8025
%ID_Notify        = 8026
%ID_NumOf         = 8027
%ID_Period        = 8028
%ID_Annual        = 8029
%ID_OneTime       = 8030
%ID_ByWeekday     = 8031
%ID_Monthly       = 8032
%ID_Weekly        = 8033
%ID_Daily         = 8034
%ID_Search        = 8050
%ID_PrnAll        = 8051
%ID_PrnEvents     = 8052
'%ID_FindNext      = 8033
'%ID_FindPrev      = 8034
'Import data --------------------------------
%ID_ImportData    = 9000

TYPE xPamRecord           '18 bytes total
  Lname AS BYTE           'length of last name
  Fname AS BYTE           'length of first name (& spouse)
  homePhone AS BYTE       'length of home phone number
  busPhone AS BYTE        'length of business phone number
  cellPhone AS BYTE       'length of cell or pager phone number
  faxPhone AS BYTE        'length of fax number
  toTitle AS BYTE         'index for personal title
  toName AS BYTE          'length of first name for mail
  addr1 AS BYTE           'length of address1
  addr2 AS BYTE           'length of address2 [country]
  city AS BYTE            'length of city, state [city, prov]
  zip AS BYTE             'length of zip)
  email AS BYTE           'length of e-mail address
  catg AS BYTE            'index for category to find by
  dataLength AS WORD      'length of data string
  flag AS INTEGER
    'bit 0 - replaced record
    'bit 1 - active record
    'bit 2 - selected record
    'bit 3 - outside USA
    'bits 4 thru 15 - lists (max of 12)
END TYPE

TYPE pamRecord            '20 bytes total
  Lname AS BYTE           'length of last name
  Fname AS BYTE           'length of first name (& spouse)
  homePhone AS BYTE       'length of home phone number
  busPhone AS BYTE        'length of business phone number
  cellPhone AS BYTE       'length of cell or pager phone number
  faxPhone AS BYTE        'length of fax number
  toTitle AS BYTE         'index for personal title
  toName AS BYTE          'length of first name for mail
  addr1 AS BYTE           'length of address1
  addr2 AS BYTE           'length of address2 [country]
  city AS BYTE            'length of city, state [city, prov]
  zip AS BYTE             'length of zip)
  email AS BYTE           'length of e-mail address
  catg AS BYTE            'index for category to find by
  dataLength AS dWORD     'length of data string
  flag AS INTEGER
    'bit 0 - replaced record
    'bit 1 - active record
    'bit 2 - selected record
    'bit 3 - outside USA
    'bits 4 thru 15 - lists (max of 12)
END TYPE

TYPE reminderType
   nEvent AS BYTE               'event (birthday, anniversary, appointment, ...)
   descr AS STRING *48          'description of event (Dr Smith, orthopedic)
   date AS LONG                 'next date for event - enter(10-13-2000)
   time AS INTEGER              'military time or year of birthday/anniversary
   adv AS BYTE                  'notify days in advance (255 max)
   period AS BYTE               'number of weeks or months per period
   annual AS BYTE               'annual = 1, oneTime = 2, weekday = 3
                                'monthly, weekly, daily period = 4,5,6
END TYPE
  
GLOBAL pamID AS STRING *10           'winPam version no
GLOBAL thisFile AS STRING            'file name including the path (stored in winPam.ini)
global remindersFile as string       'reminders file name including path (folder with thisFile)
GLOBAL helpFile AS ASCIIZ *260
'GLOBAL progFolder AS STRING          'where program files are stored (beginning with ver 2.88)
GLOBAL dataFolder AS STRING          'where data files are stored (beginning with ver 2.88)
GLOBAL pamRec() AS  pamRecord
GLOBAL pamData() AS  STRING
GLOBAL viewList() AS  INTEGER
GLOBAL viewListStr() AS  STRING
GLOBAL undel() AS LONG
GLOBAL tabs() AS  STRING
global recent() as string
GLOBAL hWin AS LONG
GLOBAL hMenu AS LONG
GLOBAL hStatus AS LONG
GLOBAL hFileMenu AS LONG
GLOBAL hEditMenu AS LONG
GLOBAL hViewMenu AS LONG
GLOBAL hListMenu AS LONG
GLOBAL hTaskMenu AS LONG
GLOBAL hHelpMenu AS LONG
GLOBAL hMouseMenu AS LONG
global hTextboxMenu as long
GLOBAL hImport AS LONG
GLOBAL hDispDC AS LONG
GLOBAL hLB AS LONG
GLOBAL gOrigLBProc AS LONG
GLOBAL ghKbdHook AS LONG
GLOBAL screenY AS LONG
GLOBAL winWidth AS LONG
GLOBAL winHeight AS LONG
GLOBAL listX AS LONG
GLOBAL listY AS LONG
GLOBAL listW AS LONG
GLOBAL listH AS LONG
GLOBAL formWidth AS LONG
GLOBAL formHeight AS LONG
GLOBAL bkgdColor AS LONG
GLOBAL tabNo AS LONG
GLOBAL maxRecords AS LONG
GLOBAL numRecords AS WORD
GLOBAL numCatgs AS WORD
GLOBAL numLists AS WORD
GLOBAL numMarked AS LONG
GLOBAL listNo AS LONG
GLOBAL listNames() AS STRING
GLOBAL myAreaCode AS STRING
GLOBAL myPrefix AS STRING
GLOBAL commPortNo AS LONG
GLOBAL leftPrnMargin AS DOUBLE
GLOBAL tabLabels AS STRING
GLOBAL myRetAddr AS STRING
GLOBAL labelSizePref AS BYTE
GLOBAL envSizePref AS BYTE
GLOBAL viewRecord AS BYTE
GLOBAL hiLite AS LONG
GLOBAL fileChanged AS BYTE
GLOBAL reloadList AS BYTE
GLOBAL recordNo AS LONG
GLOBAL numView AS LONG
GLOBAL undoLevel AS LONG
GLOBAL lineHt AS LONG
GLOBAL viewOpt AS BYTE
GLOBAL doNotQuit AS BYTE         
GLOBAL markedAs AS BYTE
GLOBAL marking AS BYTE
GLOBAL ti AS STRING
GLOBAL menuMode AS BYTE
GLOBAL listMode AS BYTE
GLOBAL remindMode AS BYTE
GLOBAL returnKey AS BYTE
GLOBAL windowNo AS BYTE
GLOBAL pwLen AS LONG
'GLOBAL password AS STRING
GLOBAL pwFile AS STRING
GLOBAL pwMode AS BYTE
GLOBAL pwVerified AS LONG
'dataForm ---------------------------------------------------
GLOBAL catg() AS STRING
global hCatg as long
global hNote as long
GLOBAL toTitle() AS STRING
GLOBAL recData() AS STRING
GLOBAL phoneID() AS STRING
global expand as long
global moreThan240 as long
GLOBAL hForm AS LONG
GLOBAL firstName AS STRING
GLOBAL lastName AS STRING
GLOBAL savedRecordNo AS INTEGER
GLOBAL notUSA AS BYTE
global editPhoneID AS BYTE
GLOBAL recError AS LONG
GLOBAL closeDlg AS BYTE
global sExpNote as string
global hExpNote as long
global gNoteProc as long
global gExpNoteProc as long 
global hExpNoteCtrl as long
global hAccel as long 
global dataPasted as long
'Labels -----------------------------------------------------
GLOBAL hLabel AS LONG
'Envelopes --------------------------------------------------
GLOBAL hEnvelope AS LONG
GLOBAL envelopeSize AS INTEGER
'Dial -------------------------------------------------------
GLOBAL hDial AS LONG
GLOBAL hPhone AS LONG
GLOBAL hComm AS DWORD
GLOBAL hLine AS DWORD
GLOBAL hCall AS DWORD                    
GLOBAL gOrigPhNoProc AS LONG
GLOBAL nPhone AS LONG
GLOBAL phoneNo() AS STRING
GLOBAL dialNo() AS STRING
GLOBAL info() AS STRING
GLOBAL xDialLast AS STRING
GLOBAL lastCalled AS LONG
GLOBAL multiCalls AS BYTE
GLOBAL callStatus AS BYTE
GLOBAL dialingNow AS BYTE
GLOBAL tapiStatus AS LINECALLSTATUS
GLOBAL hTapiApp AS DWORD
'Properties ------------------------------------------------- 
GLOBAL hProp AS LONG
GLOBAL numLabels AS INTEGER
GLOBAL numEnvelopes AS INTEGER
GLOBAL labelNo AS INTEGER
GLOBAL labelName() AS STRING
GLOBAL labelWidth() AS DOUBLE
GLOBAL labelHeight() AS DOUBLE
GLOBAL labelLeft() AS DOUBLE
GLOBAL labelTop() AS DOUBLE
GLOBAL labelSpacW() AS DOUBLE
GLOBAL labelSpacH() AS DOUBLE
GLOBAL envNo AS INTEGER
GLOBAL envName() AS STRING
GLOBAL envHorz() AS DOUBLE
GLOBAL envVert() AS DOUBLE
GLOBAL lastTab AS LONG
GLOBAL gOrigTabEdProc AS LONG
GLOBAL morePrefixes1 AS STRING
GLOBAL morePrefixes2 AS STRING
GLOBAL nPrefix AS LONG
GLOBAL sPrefix() AS STRING
GLOBAL phoneChrsQZ AS LONG
GLOBAL inclAreaCode AS LONG
'Find and Lists ---------------------------------------------
GLOBAL hFind AS LONG
GLOBAL hListName AS LONG
GLOBAL listSelected AS BYTE
GLOBAL findMode, findModeExp AS BYTE
GLOBAL findStr AS STRING
GLOBAL savedTabNo AS BYTE
'Print ------------------------------------------------------
GLOBAL hPrintOpt AS LONG
GLOBAL hAddrBook AS LONG
GLOBAL singleLine AS LONG
GLOBAL noPgBreak AS LONG
GLOBAL noHeaders AS LONG
GLOBAL fullPage AS LONG
GLOBAL halfPage AS LONG
GLOBAL miniPage AS LONG
GLOBAL largePrn AS LONG
GLOBAL frontSide AS LONG
GLOBAL backSide AS LONG
GLOBAL pgTitle AS STRING
GLOBAL fontType AS STRING
GLOBAL printOk AS BYTE
GLOBAL printingAddrBook AS BYTE
'Calendar ---------------------------------------------------
GLOBAL hCal AS LONG
GLOBAL thisMo, today, thisYr AS LONG
GLOBAL theMo, theDay, theYr AS LONG
GLOBAL xMouse, yMouse AS LONG
GLOBAL initialized AS BYTE
'Reminders ---------------------------------------------------
GLOBAL hRemind AS LONG
GLOBAL hRemindForm AS LONG
GLOBAL numReminders AS INTEGER
GLOBAL numEvents AS INTEGER
GLOBAL myReminders() AS reminderType
GLOBAL nEvents() AS STRING
GLOBAL reminderNo AS INTEGER
GLOBAL savReminders AS BYTE
GLOBAL reminderHiLite AS INTEGER
GLOBAL month() AS STRING
'Import/export -------------------------------------------------
GLOBAL portOpt AS BYTE
GLOBAL seq() AS LONG
GLOBAL hImportData() AS LONG
GLOBAL gImportData() AS LONG
GLOBAL importFln AS STRING
GLOBAL exportFln AS STRING
GLOBAL portError AS LONG

DECLARE FUNCTION HtmlHelp LIB "hhctrl.ocx" ALIAS "HtmlHelpA" _
          (BYVAL LONG, ASCIIZ, BYVAL LONG, BYVAL LONG ) AS LONG

'Program Notes ----------------------------------------------------------------------

'              inside USA      outside USA
'                           stored      displayed
'   recData(0)   Lname
'   recData(1)   Fname
'   recData(2)   homePh
'   recData(3)   busPh
'   recData(4)   cellPh
'   recData(5)   faxPh
'   recData(6)   email
'   recData(7)   toTitle
'   recData(8)   toName
'   recData(9)   addr1
'   recData(10)  addr2       postal       city
'   recData(11)  city        city         prov
'   recData(12)  zip         country      country
'   recData(13)  state       prov         postal
'   recData(14)  catg
'   recData(15)  note

'   undel(i) = deleted level of record i
'            = -1  no undo possible
   